function separateWithComma(n) {
    return String(n).replace(/(\d)(?=(\d\d\d)+(?!\d))/g, '$1,');
}

$(function() {
    $('span.item-unit').hide();

    $('#item_count').scItemCount();

    $('form.item').scItem({
        onAdd: function(data) {
            $('#modal-success').fadeIn('fast');
            $('#modal-error').css('display','none');
            $('#item_count').scItemCount('update');

            // カートへ追加した際、ボタンを無効化する場合は以下を使用する
            // $(this).find('.add-cart').find('input[type=submit]').val('カートへ追加しました')
            //     .removeClass('btn-success')
            //     .addClass('btn-secondary')
            //     .attr('disabled','disabled');
        },

        // 商品情報にエラーがある場合
        onError: function(data, method) {
            // カートに追加した際の表示
            if(method == 'add') {
                $('#modal-success').css('display','none');
                $('#modal-error').fadeIn('fast');
                $('.modal-body .error-message').text(data.error);
            }
            // ボタンを無効化表示にする
            else if(method == 'loadItem') {
                $(this).find('input[type="submit"]')
                    .attr('disabled', true)
                    .val(data.error)
                    .removeClass('btn-success')
                    .addClass('btn-secondary');
            }
        },

        loadItemData: true,

        onLoadItem: function(data) {
            var item = data.result;

            // 商品ID
            var $Id = $('span.item-id', this);
            var Id = item.id;
            $Id.html(Id);

            // 商品名
            var $name = $('span.item-name', this);
            var name = item.name;
            $name.html(name);

            // 商品価格
            var $price = $('span.item-price', this);
            var price = item.price;
            $price.html(separateWithComma(price));

            // 商品グループID
            var $groupId = $('span.item-groupid', this);
            var groupId = item.groupId;
            $groupId.html(groupId);

            // 商品在庫
            var $stock = $('span.item-stock', this);
            var $unit = $('span.item-unit', this);
            var $addCartButton = $('input[type="submit"]', this);
            var stock = Number(item.stock);
            if(!stock || isNaN(stock)) {
                $stock.html('品切れ'); // 在庫切れの際のテキスト
                $unit.hide();
                $addCartButton
                    .val('品切れ') // 在庫切れの際のテキスト
                    .attr('disabled', true)
                    .removeClass('btn-success')
                    .addClass('btn-secondary');
            }
            else {
                $stock.html(separateWithComma(stock)); // カンマ区切りを使用しない場合は $stock.html(stock); を使用する
                $unit.show();
                var fa = "\u{f217}";
                $addCartButton
                    .val(fa + ' カートへ追加')
                    .attr('disabled', false)
                    .removeClass('btn-secondary')
                    .addClass('btn-success');
            }

            // 商品重量
            var $weight = $('span.item-weight', this);
            var weight = item.weight/1000; // g表示の場合は /1000 を削除
            $weight.html(separateWithComma(weight));

        }
    });

    $('form.item [name="id"]').change(function() {
        $(this).closest('form').scItem('loadItem');
        return false;
    });

    $('#myModal').on('hide.bs.modal', function (e) {
        $('#modal-success').css('display','none');
        $('#modal-error').css('display','none');
    });
});

/* vim: set et ts=4 sts=4 sw=4: */
