<?php
/**
 * SkeletonCart
 * (c) 2017-2023 Juxtaposition Inc. All Rights Reserved.
 * (c) 2017-2023 Curlybracket, Inc. All Rights Reserved.
 * This code cannot be redistributed without permission from the copyright holder.
 * For more information, consult your SkeletonCart license.
 **/

namespace App;

/*
 * TODO: v1の互換性が必要なければ削除する。
 */
class ControllerFactory
{
    public static function create($type, $mode = null)
    {
        if (!$mode) {
            $mode = $type === 'cart' ? 'show' : 'edit';
        }

        $controller = null;
        if ($type === 'cart') {
            $controller = new CartController($type, $mode);
        } else if ($type === 'checkout') {
            $controller = new CheckoutController($type, $mode);
        } else {
            \App::notFound();
        }
        return $controller;
    }

    public static function createCompat()
    {
        $controllerName = \App::request()->query->qp0;
        $controller = null;
        if ($controllerName == 'idx') {
            $controller = new CartController();
        } else if ($controllerName == 'reg') {
            $controller = new CheckoutController();
        } else {
            $controller = new CartController();
        }
        return $controller;
    }

}

