<?php
/**
 * SkeletonCart
 * (c) 2017-2023 Juxtaposition Inc. All Rights Reserved.
 * (c) 2017-2023 Curlybracket, Inc. All Rights Reserved.
 * This code cannot be redistributed without permission from the copyright holder.
 * For more information, consult your SkeletonCart license.
 **/

namespace App;

class StockAllocator
{
    protected $cart = null;
    protected $itemModel = null;

    public function __construct($cart = null, $itemModel = null)
    {
        $this->cart = $cart;
        $this->itemModel = $itemModel;
    }

    public function setCart($cart)
    {
        $this->cart = $cart;
    }

    public function setItemModel($itemModel)
    {
        $this->itemModel = $itemModel;
    }

    public function allocate()
    {
        if (!isset($this->cart)) {
            throw new \UnexpectedValueException('Missing argument - cart');
        }
        if (!isset($this->itemModel)) {
            throw new \UnexpectedValueException('Missing argument - itemModel');
        }
        foreach ($this->cart->items() as $cartItem) {
            $item = $this->itemModel->find($cartItem->id());
            if ($item) {
                $item->allocateStock($cartItem->amount());
                $item->save();
            }
        }
    }

    public function save()
    {
        $this->itemModel->itemList()->save();
    }
}
