<?php
/**
 * SkeletonCart
 * (c) 2017-2023 Juxtaposition Inc. All Rights Reserved.
 * (c) 2017-2023 Curlybracket, Inc. All Rights Reserved.
 * This code cannot be redistributed without permission from the copyright holder.
 * For more information, consult your SkeletonCart license.
 **/

namespace App;

class StockChecker implements CartItemChecker
{
    protected $itemModel = null;

    public function __construct($itemModel)
    {
        if (!isset($itemModel)) {
            throw new \UnexpectedValueException('Missing argument - itemModel');
        }
        $this->itemModel = $itemModel;
    }

    public function check(CartItem $cartItem)
    {
        $item = $this->itemModel->find($cartItem->id());
        if ($item === false) {
            $cartItem->setError('商品名:' . $cartItem->name() . '（商品ID:' . $cartItem->id() . '）は注文できません。');
        } elseif ($cartItem->amount() > $item->stock()) {
            $cartItem->setError("商品名:" . $item->name() . "は在庫がありません。(在庫：" . $item->stock() . "）");
        } else {
            $cartItem->clearError();
        }
    }
}

